Subject: Re: "git-stash --keep-index" crashes when there are no tracked files

From: Patrick Steinhardt <[email-masked]>
Date: Fri, 16 Aug 2024 12:39:51 +0200

On Tue, Aug 13, 2024 at 07:36:15PM +0200, Piotr Siupa wrote:
> Hello,
> 
> I've found a bug.
> It's something that's unlikely to happen in a normal workflow but it
> breaks a script I'm trying to write.
> 
> Here is the complete report from "git bugreport":
> 
> Thank you for filling out a Git bug report!
> Please answer the following questions to help us understand your issue.
> 
> What did you do before the bug happened? (Steps to reproduce your issue)
> git init
> git commit --allow-empty --message='initial commit'
> touch foo
> git stash push --include-untracked --keep-index
> 
> What did you expect to happen? (Expected behavior)
> A stash entry storing the untracked file "foo" should be created. The
> working directory and index should become empty.
> 
> What happened instead? (Actual behavior)
> The command did what was expected but after that it crashed with the
> following error message:
> error: pathspec ':/' did not match any file(s) known to git

I would clarify that this is not "crashing", but that's basically
splitting hairs. In any case, thanks for this clear bug report with a
nice and simple reproducer. I agree that this is something that should
be fixed indeed.

Will send a patch shortly.

Patrick